

#import "GameScene.h"

#import "InGameLayer.h"
#import "DataManager.h"
#import "MenuLayer.h"

@interface GameScene (Private)

- (void) endGame;

@end

#define frameRate 0.1

@implementation GameScene

@synthesize menuLayer;
@synthesize dataManager;
//@synthesize mGameLayer;

- (void) dealloc
{
	[self unschedule:@selector(tick:)];
	[menuLayer release];
	//[mainLayer release];
	[dataManager release];
	[inGameLayer release];
	[super dealloc];
}

- (id) init
{
	self = [super init];
	
	if (self)
	{
		dataManager = [DataManager sharedManager];
		//dataManager.currentlevel = 0;
		//dataManager.score = 0;
		//dataManager.misses = 1;
		
		//GameLayer *layer = [[GameLayer alloc] init];
		//self.mainLayer = layer;
		//[layer release];
		
		//mainLayer.delegate = self;
		
		//[self addChild:mainLayer];
		
		InGameLayer *gameLayer = [[InGameLayer alloc] init];
		inGameLayer = gameLayer;
		[gameLayer release];
		
		inGameLayer.Delegate = self;		
		
		//[self addChild:inGameLayer];
		
		//[self schedule: @selector(tick:) interval:frameRate];
		
		[self endGame];		
	}
	
	return self;
}

- (void) tick: (ccTime) dt
{	
	//if(dataManager.score > -1) [mainLayer setScore:dataManager.score];
	//[mainLayer setMisses:dataManager.misses];
}

- (void) endGame
{
	if(menuLayer == nil)
	{
		MenuLayer *menu = [[MenuLayer alloc] init];
		self.menuLayer = menu;
		[menu release];
		
		menuLayer.Delegate = self;
	}
	
	//[self removeChild:mGameLayer cleanup:NO];
	//if ([self.children containsObject:inGameLayer])
	//	[self removeChild:inGameLayer cleanup:YES];	
	//if (![self.children containsObject:menuLayer])
	if ([self.children containsObject:inGameLayer])
		[self removeChild:inGameLayer	cleanup:YES];
	[self addChild:menuLayer];
}

- (void) restartGame
{
	//if(menuLayer != nil) 
	//	[self removeChild:menuLayer cleanup:NO];
	
	//dataManager.currentlevel = 0;
	//dataManager.currentindex = 0;
	//dataManager.misses = 1;
	//dataManager.score = 0;
	//dataManager.missed = NO;
	
	//[mainLayer loadLevel:[[dataManager levels] objectAtIndex:dataManager.currentlevel]];
	
	//[self disableMenu];
	if ([self.children containsObject:menuLayer])
		[self removeChild:menuLayer	cleanup:YES];
	[self addChild:inGameLayer];
	//[inGameLayer resetGame];
	//[mGameLayer resetGame];
}

- (void) disableMenu
{
	menuLayer.enable = NO;
}

- (void) enableMenu
{
	menuLayer.enable = YES;
}

@end
