//
//  iCountSecondsAppDelegate.m
//  iCountSeconds
//
//  Created by Bao Weiwei on 9/28/09.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "iCountSecondsAppDelegate.h"
#import "InGameLayer.h"

//lxz added
#import "OpenFeint.h"

#define AD_HEIGHT 48

@interface iCountSecondsAppDelegate()
//-(void) setUpAudioManager:(NSObject*) data;
@end

@implementation iCountSecondsAppDelegate

// window is a property. @synthesize will create the accesors methods
@synthesize window;

// Application entry point
- (void) applicationDidFinishLaunching:(UIApplication*)application
{
	UIApplication *thisApp = [UIApplication sharedApplication];
	thisApp.idleTimerDisabled = YES;
		
	// create an initilize the main UIWindow
	window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
	[window setUserInteractionEnabled:YES];   
	
	//[[CCDirector useFastDirector];
	//[Texture2D setDefaultAlphaPixelFormat:kTexture2DPixelFormat_RGB5A1];
	// Attach cocos2d to the window
	[[CCDirector sharedDirector] attachInWindow:window];
	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fullPageOpenAdNotification:) name:FULL_PAGE_AD_OPEN_NOTIFICATION object:nil]; 
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fullPageCloseAdNotification:) name:FULL_PAGE_AD_CLOSE_NOTIFICATION object:nil]; 
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fullPageFailureAdNotification:) name:FULL_PAGE_AD_FAILURE_NOTIFICATION object:nil]; 
	
	TapjoyConnectInterface *ti = [[TapjoyConnectInterface alloc] init];
	TapjoyConnect *tc = [TapjoyConnect requestTapjoyConnectWithDelegate:ti];
	[tc getAdOrder];
	[tc preloadAds:1];
	
	TJCAdView *adView = [tc showAdBox:1 rect:CGRectMake(0,window.frame.size.height-AD_HEIGHT, window.frame.size.width, AD_HEIGHT) WithDelegate:self];
	[adView setAutoresizingMask:UIViewAutoresizingFlexibleTopMargin];
	[window addSubview:adView];
#ifdef DEBUG
	mAdNameLabel = [[UILabel alloc]initWithFrame:CGRectMake(70, 0, 240, 30)];
	[[CCDirector sharedDirector].openGLView addSubview:mAdNameLabel];
	mAdNameLabel.text = @"Name of network:";
#endif
	// before creating any layer, set the landscape mode
	//[[[CCDirector sharedDirector] setDeviceOrientation:CCDeviceOrientationLandscapeLeft];
	
	///[[CCDirector sharedDirector].displayFPS = YES;
	// Make the window visible
	[window makeKeyAndVisible];
		
	mInGameScene = [[CCScene alloc] init];
	[mInGameScene addChild:[InGameLayer node] z:0 tag:0];
	((InGameLayer*)[mInGameScene getChildByTag:0]).Delegate = self;
		
	[[CCDirector sharedDirector] runWithScene:mInGameScene];
		
	SimpleAudioEngine* sae = [SimpleAudioEngine sharedEngine];
	//[sae playBackgroundMusic:@"menu_loop.caf" loop:YES];
	//[sae setBackgroundMusicVolume:[sae backgroundMusicVolume]*0.4];
	[sae setEffectsVolume:[sae effectsVolume]*1.1];
	[sae preloadEffect:kButtonSE];
	
	//lxz added initialize openfeint
	[self initializeOpenfeint:window];
}

//lxz added openfeint
-(void) applicationWillResignActive:(UIApplication *)application
{
	[OpenFeint applicationWillResignActive];
}

-(void) applicationDidBecomeActive:(UIApplication *)application
{
	[OpenFeint applicationDidBecomeActive];
}

- (void) applicationWillTerminate:(UIApplication*)application
{
	//lxz added openfeint
	//[ofDelegate release];
	[[TapjoyConnect requestTapjoyConnectWithDelegate:nil] disconnect];
	
#ifdef DEBUG
	[mAdNameLabel release];
#endif
	[mInGameScene retainCount];
	[[CCDirector sharedDirector] popScene];
	[mInGameScene release];
	[window release];
}

- (void) dealloc
{	
	[super dealloc];
}

//lxz added
- (void)initializeOpenfeint:(UIWindow *)awindow
{
	NSDictionary* settings = [NSDictionary dictionaryWithObjectsAndKeys:
							  [NSNumber numberWithInt:UIInterfaceOrientationPortrait], OpenFeintSettingDashboardOrientation,
							  DISPLAY_SHORT_NAME, OpenFeintSettingShortDisplayName,
							  [NSNumber numberWithBool:NO], OpenFeintSettingEnablePushNotifications,
							  //[NSNumber numberWithBool:YES], OpenFeintSettingDisableChat,
  							  [NSNumber numberWithBool:NO], OpenFeintSettingAlwaysAskForApprovalInDebug,
							  awindow, OpenFeintSettingPresentationWindow,
							  nil
							  ];
	InGameLayer* inGameLayer = ((InGameLayer*)[mInGameScene getChildByTag:0]);
	//ofDelegate = [[SampleOFDelegate alloc] init];
	[inGameLayer showCustomOpenFeintApprovalScreen];
	
	OFDelegatesContainer* delegates = [OFDelegatesContainer containerWithOpenFeintDelegate:inGameLayer
																	  andChallengeDelegate:nil
																   andNotificationDelegate:nil];
	
    [OpenFeint initializeWithProductKey:PRODUCT_KEY
                              andSecret:PRODUCT_SECRET
                         andDisplayName:DISPLAY_NAME
                            andSettings:settings				 // see OpenFeintSettings.h
                           andDelegates:delegates];              // see OFDelegatesContainer.h
}

-(void) fullPageOpenAdNotification:(NSNotification*)notifyObj
{
	NSLog(@"Full Page Ad Shown");
}

-(void) fullPageCloseAdNotification:(NSNotification*)notifyObj
{
	NSLog(@"Full Page Ad Closed");
}

-(void) fullPageFailureAdNotification:(NSNotification*)notifyObj
{
	NSLog(@"Ad Failure with Message:%@",notifyObj.object);
}

-(void) adIsShown:(TJCAdView*) adView
{
	NSLog(@"adshown in client api called with libname %@ ", [adView getAdLibraryName]);
	NSLog(@"Ad width = %f    Ad height = %f ",[adView getAdSize].width, [adView getAdSize].height);
#ifdef DEBUG
	mAdNameLabel.text = [NSString stringWithFormat:@"Name of network: %@",[adView getAdLibraryName]];
#endif
	return;
}

@end
